/**
 * Created by inkheart on 10/14/14.
 */
angular.module('Court')

    .controller('RootCtrl',
    function ($rootScope,
              $scope,
              $ionicModal,
              $timeout,
              Factory,
              Connection1,
              Connection,
              $ionicLoading,
              $ionicScrollDelegate,
              $ionicPopup,
              $localstorage,
              DelegateHandle) {
        // Form data for the login modal
        $scope.searchParams = {};
        $scope.loginData = {};

        //$scope.searchData = {};
        $scope.models = Factory.models;
        $scope.resetSearchParams = function () {
            $scope.searchParams = {};
            $scope.searchData = {};
			$scope.models[$rootScope.model_section][$rootScope.section_type].searchData = {};
        };


        $scope.logout = function () {
            $localstorage.setObject('auth', {
                username: '',
                logged: false
            });
            $rootScope.authData.logged = false;
        };

//============================================================================

        $scope.showAlert = function() {
            var alertPopup = $ionicPopup.alert({
                title: 'Алдаа!',
                template: 'Нэвтрэх нэр эсвэл нууц үг буруу байна.'
            });
            alertPopup.then(function(res) {
                console.log('Thank you for not eating my delicious ice cream cone', res);
            });
        };

        $ionicModal.fromTemplateUrl('templates/modals/login.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.loginModal = modal;
        });

        $scope.openLogin = function () {
            $scope.loginModal.show();
        };

        $scope.closeLogin = function () {
            $scope.loginModal.hide();
        };

//      Хайлын мэдээлэл боловсруулах

        $scope.doAuth = function () {
            $ionicLoading.show({
                template: 'Уншиж байна...'
            });
            Connection.r('login', $scope.loginData).then(function (res) {
                if(res.logged){
                    $localstorage.setObject('auth', {
                        username: $scope.loginData.username,
                        logged: res.logged
                    });
                    $timeout(function(){
                        $rootScope.authData = {
                            logged: true,
                            username: $scope.loginData.username
                        }
                        $ionicLoading.hide();
                    },1000)
                    $scope.closeLogin()
                } else {
                    $ionicLoading.hide();
                    $scope.showAlert();
                }

            }, function (err) {
                $scope.shuugchs = [{name: 'Мэдээлэл байхгүй!'}]
                $scope.closeShuukhModal();
            })
        };
//============================================================================

// Create the search modal дэлгэрэнгүй хайлт хийх цонх үүсгэж байна
        $ionicModal.fromTemplateUrl('templates/modals/search.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.searchModal = modal;
        });

        // Triggered in the login modal to close it
        $scope.closeSearch = function () {
            $scope.searchModal.hide();
        };

        // Open the login modal
        $scope.openSearch = function (model_section, section_type) {
            $scope.searchModal.show();
        };

        // Perform the login action when the user submits the login form
        $scope.doSearch = function (model_section, section_type) {
            $ionicLoading.show({
                template: ' Хайж байна...'
            });

            delete $scope.searchParams

            console.log('Doing search...', $scope.models[model_section][section_type].searchData);
            var url = model_section + section_type + '/search';
            $scope.searchParams = DelegateHandle.reFormatSearchObj($scope.models[model_section][section_type].searchData)
            $timeout(function () {
                Connection1.r(url, $scope.searchParams).then(function (res) {
                    $ionicScrollDelegate.scrollTop();
                    Factory.models[model_section][section_type].list = res.data;
                    Factory.models[model_section][section_type].header.total  = res.header.total;
                    $ionicLoading.hide();
                    $scope.closeSearch();
                }, function (err) {
                    $ionicLoading.hide();
                    $scope.closeSearch();
                });
                // Simulate a login delay. Remove this and replace with your login
                // code if using a login system
            }, 1000);
        };


//============================================================================

        $ionicModal.fromTemplateUrl('templates/modals/shuukhs.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.shuukhModal = modal;
        });

        $scope.doShuukh = function () {
            $scope.shuukhModal.show();
        };

        $scope.closeShuukhModal = function () {
            $scope.shuukhModal.hide();
        };

//      Хайлын мэдээлэл боловсруулах

        $scope.selectShuukh = function (item) {
            $scope.models[$rootScope.model_section][$rootScope.section_type].searchData.shuuh = item;

            Connection1.r('get/shuugch', {shuuh: item.id}).then(function (res) {
                $scope.models.options[$rootScope.model_section][$rootScope.section_type].shuugch = res;
                delete $scope.models[$rootScope.model_section][$rootScope.section_type].searchData.shuugch
                $scope.closeShuukhModal();
            }, function (err) {
                $scope.shuugchs = [{name: 'Мэдээлэл байхгүй!'}]
                $scope.closeShuukhModal();
            })
        };
//============================================================================

        $ionicModal.fromTemplateUrl('templates/modals/shuukhchs.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.shuukhchsModal = modal;
        });

        $scope.doShuukhchs = function () {
            if ($scope.models.options[$rootScope.model_section][$rootScope.section_type].shuugch) {
                $scope.shuukhchsModal.show();
            }
        };

        $scope.closeShuukhchsModal = function () {
            $scope.shuukhchsModal.hide();
        };

//      Хайлын мэдээлэл боловсруулах

        $scope.selectShuukhch = function (item) {
            $scope.models[$rootScope.model_section][$rootScope.section_type].searchData.shuugch = item
            $scope.closeShuukhchsModal();
        };
//============================================================================


        $ionicModal.fromTemplateUrl('templates/modals/margaan.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.margaanModal = modal;
        });

        $scope.doMargaan = function () {
            $scope.margaanModal.show();
        };

        $scope.closeMargaanModal = function () {
            $scope.margaanModal.hide();
        };

//      Хайлын мэдээлэл боловсруулах

        $scope.selectMargaan = function (item) {
            $scope.models[$rootScope.model_section][$rootScope.section_type].searchData.margaan = item
            $scope.closeMargaanModal();
        };

//============================================================================


        $ionicModal.fromTemplateUrl('templates/modals/zuil.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.zuilModal = modal;
        });

        $scope.doZuil = function () {
            $scope.zuilModal.show();
        };

        $scope.closeZuilModal = function () {
            $scope.zuilModal.hide();
        };

//      Хайлын мэдээлэл боловсруулах

        $scope.selectZuil = function (item) {
            $scope.models[$rootScope.model_section][$rootScope.section_type].searchData.zuil = item
            $scope.closeZuilModal();
        };
//============================================================================


        $ionicModal.fromTemplateUrl('templates/modals/hariutsagch.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.hariutsagchModal = modal;
        });

        $scope.doHariutsagch = function () {
            $scope.hariutsagchModal.show();
        };

        $scope.closeHariutsagchModal = function () {
            $scope.hariutsagchModal.hide();
        };

//      Хайлын мэдээлэл боловсруулах

        $scope.selectHariutsagch = function (item) {
            $scope.models[$rootScope.model_section][$rootScope.section_type].searchData.hariutsagch = item
            $scope.closeHariutsagchModal();
        };
//============================================================================

        $ionicModal.fromTemplateUrl('templates/citizen/detail.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.itemDetailModal = modal;
        });

        $scope.doItemDetail = function (id, model_section, section_type) {
            $ionicScrollDelegate.scrollTop();
            $scope.itemMoreDetailLoaded = false;

            $ionicLoading.show({
                template: 'Уншиж байна...'
            });
            var url = model_section + section_type + '/view';
            Connection1.r(url, {id: id}).then(function (res) {
                $scope.itemDetailModal.show();
                $scope.detailSectionType = section_type;
                $scope.detailItems = res.data;
                $scope.other_anhan = res.other_anhan
                $scope.other_davah = res.other_davah
                $scope.other_hyanalt = res.other_hyanalt
                $scope.itemMoreDetailLoaded = false;
                $ionicLoading.hide();
            }, function (err) {
                $ionicLoading.hide();
            });
        };

        $scope.closeItemDetail = function () {
            $scope.itemDetailModal.hide();
        };

        $scope.moreItemDetail = function (id, model_section, section_type) {
            console.log('id: ', id)
            console.log('model_section: ', model_section)
            console.log('section_type: ', section_type)
            if ($rootScope.authData.logged) {
                $ionicLoading.show({
                    template: 'Уншиж байна...'
                });
                var url = model_section + section_type + '/detail';
                Connection1.r(url, {id: id}).then(function (res) {
                    $ionicScrollDelegate.scrollTop();
                    $scope.detailItems = res.data;
                    $scope.itemMoreDetailLoaded = true;
                    $ionicLoading.hide();
                }, function (err) {
                    $ionicLoading.hide();
                });
            } else {
                $scope.openLogin();
            }

        };

//============================================================================

        $scope.loadMore = function (model_section, section_type) {
            $scope.searchParams = DelegateHandle.reFormatSearchObj($scope.models[model_section][section_type].searchData)
            $scope.searchParams.offset = $scope.models[model_section][section_type].list.length;
            var url = model_section + section_type + '/search';
            $timeout(function () {
                Connection1.r(url, $scope.searchParams).then(function (res) {
                    res.data.forEach(function (e, i) {
                        $scope.models[model_section][section_type].list.push(e);
                    })
                    $scope.itemLength = $scope.models[model_section][section_type].list.length
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                }, function (err) {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                });
            }, 2000)
        };

        $scope.doRefresh = function (model_section, section_type) {
			console.log('$scope.models: ', $scope.models)
			console.log('$scope.models: ', model_section)
			console.log('$scope.models: ', section_type)
            $timeout(function () {
                var url = model_section + section_type + '/search';
                Factory.loadData($scope.models[model_section][section_type], url, {}, function (res, err) {
                    if(err) {
                        $scope.$broadcast('scroll.refreshComplete');
                        return;
                    }
                    $scope.$broadcast('scroll.refreshComplete');
                    $scope.itemLength = $scope.models[model_section][section_type].list.length
                })
                $scope.resetSearchParams();
            }, 1000);
        };


    })


