/**
 * Created by inkheart on 10/20/14.
 */
angular.module('Court')
    .controller('MapCtrl',
    function (
        $rootScope,
        $scope,
        $ionicLoading,
        $compile,
        $ionicPlatform,
        Connection1,
        $ionicModal,
        $timeout,
        $ionicScrollDelegate,
        $state,
        $ionicActionSheet,
        DelegateHandle,
        Factory) {


        $scope.selectedMap = {};
        $scope.selectedMapTab = 0;
        $scope.mapLoading = false;
		$scope.tabTitle = 'Анхан шат';
        // Triggered on a button click, or some other target
        $scope.openActionSheet = function (item) {
            var buttons = []
			console.log('item.shiidver: ', item.shiidver)
            if (_.isArray(item.shiidver)) {
                _.each(item.shiidver, function () {
                    var button = {};
                    button.text = e.name;
                    button.module = e.module;
                    button.shuukh_id = item.id;
                    buttons.push(button);
                })
            } else {
                var button = {};
                button.text = item.shiidver.name;
                button.module = item.shiidver.module;
				button.shuukh_id = item.id;
                buttons.push(button);
            }

            // Show the action sheet
            var hideSheet = $ionicActionSheet.show({
                buttons: buttons,
                titleText: 'Шүүхийн шийдвэрүүд',
                cancelText: 'Болих',
                cancel: function () {
                    // add cancel code..
                },
                buttonClicked: function (index) {
                    console.log('index: ', index)
                    $ionicLoading.show({
                        template: 'Уншиж байна...'
                    });
                    var button = buttons[index]

                    var model,type,searchParam;
                    if (button.module.indexOf("irgen") == 0) {
                        if($scope.selectedMapTab == 0){model = 'irgen'; type = 'anhan'}
                        if($scope.selectedMapTab == 1){model = 'irgen'; type = 'davah'}
                        if($scope.selectedMapTab == 2){model = 'irgen'; type = 'hyanalt'}
                    } else if (button.module.indexOf("eruu") == 0) {
                        if($scope.selectedMapTab == 0){model = 'eruu'; type = 'anhan'}
                        if($scope.selectedMapTab == 1){model = 'eruu'; type = 'davah'}
                        if($scope.selectedMapTab == 2){model = 'eruu'; type = 'hyanalt'}
                    } else if (button.module.indexOf("zahirgaa" == 0)) {
                        if($scope.selectedMapTab == 0){model = 'zahirgaa'; type = 'anhan'}
                        if($scope.selectedMapTab == 1){model = 'zahirgaa'; type = 'davah'}
                        if($scope.selectedMapTab == 2){model = 'zahirgaa'; type = 'hyanalt'}
                    }
                    console.log('model: ', model)
                    console.log('type: ', type)
                    console.log('button: ', button)
                    console.log('button.module.indexOf("zahirgaa"): ', button.module.indexOf("zahirgaa"))
                    Factory.models[model][type].searchData.shuuh = {id: button.shuukh_id};
console.log('Factory.models[model][type].searchData: ', Factory.models[model][type].searchData)
                    searchParam = DelegateHandle.reFormatSearchObj(Factory.models[model][type].searchData)
                        console.log('searchParam: ', searchParam)
                    var url = model + type + '/search';
                    Factory.loadData($scope.models[model][type], url, searchParam, function (res) {
                        $ionicScrollDelegate.scrollTop();
                        Factory.models[model][type].list.length = res.data.length;
                        Factory.models[model][type].header.total  = res.header.total;
                        $rootScope.selectModel(model, type)
                        $scope.closeMapModal();
                        $ionicLoading.hide();
                    })
                }
            });
        };

        var vm = this;
        vm.googleMap = null;
        vm.mapMarkers = [];
        vm.shuukhMarker = $scope.models.shuukh_map.anhan;

        var onSuccess = function (position) {
            vm.userLocation.coords.latitude = position.coords.latitude;
            vm.userLocation.coords.longitude = position.coords.longitude;

            initializeMap();
        };

        var onError = function (error) {
            alert('code: ' + error.code + '\n' + 'message: ' + error.message);
        };

        vm.userLocation = {
            id: "home",
            title: "home",
            coords: {
                latitude: 47.918795,
                longitude: 106.916884
            },
            options: {
                animation: google.maps.Animation.BOUNCE
            }
        };

        var image = {
            url: 'images/beachflag.png',
            // This marker is 20 pixels wide by 32 pixels tall.
            size: new google.maps.Size(20, 32),
            // The origin for this image is 0,0.
            origin: new google.maps.Point(0, 0),
            // The anchor for this image is the base of the flagpole at 0,32.
            anchor: new google.maps.Point(0, 32)
        };

        var addMarkers = function () {
            clearMarkers()
            vm.mapMarkers = [];
            angular.forEach(vm.shuukhMarker, function (location, index) {

                var marker = new google.maps.Marker({
                    map: vm.googleMap,
                    position: new google.maps.LatLng(location.latitude, location.longitude),
                    title: location.name,
                    animation: google.maps.Animation.DROP,
                    obj: location
                });

                google.maps.event.addListener(marker, 'click', function () {
                    $scope.openMapModal(marker.obj);
                });

                vm.mapMarkers.push(marker);
            });


            var bounds = new google.maps.LatLngBounds();

            for (var i = 0; i < vm.mapMarkers.length; i++) {
                bounds.extend(vm.mapMarkers[i].getPosition());
            }
            vm.googleMap.setCenter(bounds.getCenter());
            vm.googleMap.fitBounds(bounds);
            //remove one zoom level to ensure no marker is on the edge.
            vm.googleMap.setZoom(vm.googleMap.getZoom() + 1);

            // set a minimum zoom
            // if you got only 1 marker or all markers are on the same address map will be zoomed too much.
            if (vm.googleMap.getZoom() > 15) {
                vm.googleMap.setZoom(15);
            }

        };

        var initializeMap = function () {
            var mapOptions = {
                mapTypeId: google.maps.MapTypeId.ROADMAP,
                zoom: 16,
                center: new google.maps.LatLng(vm.userLocation.coords.latitude, vm.userLocation.coords.longitude)
            };
            var div = document.getElementById("mainMap");
            vm.googleMap = new google.maps.Map(div, mapOptions);

            addMarkers();

            var width = screen.width;
            var height = screen.height;
        };


        // Sets the map on all markers in the array.
        function setAllMap(map) {
            for (var i = 0; i < vm.mapMarkers.length; i++) {
                vm.mapMarkers[i].setMap(map);
            }
        }

// Removes the markers from the map, but keeps them in the array.
        function clearMarkers() {
            setAllMap(null);
        }

// Deletes all markers in the array by removing references to them.
        function deleteMarkers() {
            clearMarkers();
            markers = [];
        }

        $scope.anhan = function () {
			$scope.tabTitle = 'Анхан шат';
            if ($scope.selectedMapTab != 0) {
                $scope.mapLoading = true;
                $timeout(function () {
                    $scope.mapLoading = false;
                    vm.shuukhMarker = $scope.models.shuukh_map.anhan;
                    addMarkers();
                    $scope.selectedMapTab = 0;
                }, 800)
            }
        };

        $scope.davah = function () {
			$scope.tabTitle = 'Давж заалдах шат';
            if ($scope.selectedMapTab != 1) {
                $scope.mapLoading = true;
                $timeout(function () {
                    $scope.mapLoading = false;
                    vm.shuukhMarker = $scope.models.shuukh_map.davah;
                    addMarkers();
                    $scope.selectedMapTab = 1;
                }, 800)
            }
        };

        $scope.hyanah = function () {
			$scope.tabTitle = 'Хяналтын шат';
            if ($scope.selectedMapTab != 2) {
                $scope.mapLoading = true;
                $timeout(function () {
                    $scope.mapLoading = false;
                    vm.shuukhMarker = $scope.models.shuukh_map.hyanah;
                    addMarkers();
                    $scope.selectedMapTab = 2;
                }, 800)
            }
        };

        initializeMap();


        //============================================================================

        $ionicModal.fromTemplateUrl('templates/modals/mapModal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.mapModal = modal;
        });

        $scope.openMapModal = function (mapItem) {
            $ionicScrollDelegate.scrollTop();
            $scope.mapItem = mapItem;
            console.log('mapItem: ', mapItem)
            $scope.mapModal.show();

        };

        $scope.doShiidver = function (model_section, section_type, mapItem) {

            console.log('model_section: ', model_section)
            console.log('section_type: ', section_type)

            //$state.go('app.tabs.'+ model_section +'-'+ section_type)
        };

        $scope.closeMapModal = function () {
            $scope.mapModal.hide();
        };

//      Хайлын мэдээлэл боловсруулах


        //navigator.geolocation.getCurrentPosition(onSuccess, onError);
    });
