/**
 * Created by bilgee on 9/16/14.
 */
'use strict';

angular.module('Court')
    .factory('Factory', function Factory(Connection, Connection1) {
        var models = {
            loading: false,
            static: {},
            totalStatic: {
                hereg: 0,
                shiidver: 0
            },
            toim: {
                list: [],
                header: {
                    total: 0
                },
                searchData: {}
            },
            zar: {
                list: [],
                header: {
                    total: 0
                },
                searchData: {}
            },
            irgen: {
                anhan: {
                    list: [],
                    header: {
                        total: 0
                    },
                    searchData: {},
                    selected: null
                },
                davah: {
                    list: [],
                    header: {
                        total: 0
                    },
                    searchData: {},
                    selected: null
                },
                hyanalt: {
                    list: [],
                    header: {
                        total: 0
                    },
                    searchData: {},
                    selected: null
                }
            },
            eruu: {
                anhan: {
                    list: [],
                    header: {
                        total: 0
                    },
                    searchData: {},
                    selected: null
                },
                davah: {
                    list: [],
                    header: {
                        total: 0
                    },
                    searchData: {},
                    selected: null
                },
                hyanalt: {
                    list: [],
                    header: {
                        total: 0
                    },
                    searchData: {},
                    selected: null
                }
            },
            zahirgaa: {
                anhan: {
                    list: [],
                    header: {
                        total: 0
                    },
                    searchData: {},
                    selected: null
                },
                davah: {
                    list: [],
                    header: {
                        total: 0
                    },
                    searchData: {},
                    selected: null
                },
                hyanalt: {
                    list: [],
                    header: {
                        total: 0
                    },
                    searchData: {},
                    selected: null
                }
            },
            lavlagaa: [],
            options: {
                irgen: {
                    margaan: [],
                    anhan: {
                        shuukh: [],
                        shuugch: []
                    },
                    davah: {
                        shuukh: [],
                        shuugch: []
                    },
                    hyanalt: {
                        shuukh: [],
                        shuugch: []
                    }
                },
                eruu: {
                    zuilzaalt: [],
                    anhan: {
                        shuukh: [],
                        shuugch: []
                    },
                    davah: {
                        shuukh: [],
                        shuugch: []
                    },
                    hyanalt: {
                        shuukh: [],
                        shuugch: []
                    }
                },
                zahirgaa: {
                    margaan: [],
                    hariutsagch: [],
                    anhan: {
                        shuukh: [],
                        shuugch: []
                    },
                    davah: {
                        shuukh: [],
                        shuugch: []
                    },
                    hyanalt: {
                        shuukh: [],
                        shuugch: []
                    }
                },
                huchintei: [
                    {
                        name: "Тийм",
                        value: 1
                    },
                    {
                        name: "Үгүй",
                        value: -1
                    }
                ]
            },
            shuukh_map: {
                anhan: [],
                davah: [],
                hyanah: []
            },
            main_sections: [
                {
                    name: 'irgen',
                    types: [
                        'anhan',
                        'davah'
                    ]
                },
                {
                    name: 'eruu',
                    types: [
                        'anhan',
                        'davah'
                    ]
                },
                {
                    name: 'zahirgaa',
                    types: [
                        'anhan',
                        'davah'
                    ]
                }
            ],
            selected: null
        }

        var searchData = {
            limit: 10
        }

        function init(callback) {

            Connection1.r('get/too', {}).then(function (res1) {
                models.static = res1[0];

                if(res1[0].eruu_hereg){
                    models.totalStatic.hereg = parseInt(res1[0].eruu_hereg) + parseInt(res1[0].irgen_hereg) + parseInt(res1[0].zahirgaa_hereg);
                    models.totalStatic.shiidver = parseInt(res1[0].eruu_shiidver) + parseInt(res1[0].irgen_shiidver) + parseInt(res1[0].zahirgaa_shiidver);

                } else {
                    models.totalStatic.hereg = res1[0].hereg;
                    models.totalStatic.shiidver = res1[0].shiidver;
                }

                Connection.r('shuuh/anhan', {}).then(function (map1) {
                    models.shuukh_map.anhan = map1;
                    Connection.r('shuuh/davah', {}).then(function (map2) {
                        models.shuukh_map.davah = map2;
                        Connection.r('shuuh/hyanah', {}).then(function (map3) {
                            models.shuukh_map.hyanah = map3;
                            Connection1.r('get/irgenmargaan', {}).then(function (res2) {
                                models.options.irgen.margaan = res2;

                                Connection1.r('get/zuilzaalt', {}).then(function (res3) {
                                    models.options.eruu.zuilzaalt = res3;

                                    Connection1.r('get/zahirgaahariutsagch', {}).then(function (res4) {
                                        models.options.zahirgaa.hariutsagch = res4;

                                        Connection1.r('get/zahirgaamargaan', {}).then(function (res5) {
                                            models.options.zahirgaa.margaan = res5;

                                            Connection1.r('shuuh/hyanalt', {}).then(function (res6) {
                                                angular.forEach(models.main_sections, function (section, i) {
                                                    models.options[section.name].hyanalt.shuukh = res6;
                                                    angular.forEach(section.types, function (type, i) {
                                                        Connection1.r('shuuh/' + section.name + type, {}).then(function (res7) {
                                                            models.options[section.name][type].shuukh = res7;
                                                        }, function (err) {
                                                        });
                                                    })
                                                })
                                            }, function (err) {
                                            });
                                        }, function (err) {
                                        });

                                    }, function (err) {
                                    });

                                }, function (err) {
                                });

                            }, function (err) {
                            });
                        }, function (err) {
                        });
                    }, function (err) {
                    });
                }, function (err) {
                });

                Connection1.r('lavlagaa/menu', {}).then(function (res) {
                    models.lavlagaa = res;
                }, function (err) {
                });


                loadData1(models.zar, 'zar/search', searchData, function () {
                    loadData1(models.toim, 'toim/search', searchData, function () {

                    })
                })

                //    irgen load data
                loadData(models.irgen.anhan, 'irgenanhan/search', searchData, function () {
                    loadData(models.irgen.davah, 'irgendavah/search', searchData, function () {
                        loadData(models.irgen.hyanalt, 'irgenhyanalt/search', searchData, function () {

                        })
                    })
                })


                loadData(models.eruu.anhan, 'eruuanhan/search', searchData, function () {
                    loadData(models.eruu.davah, 'eruudavah/search', searchData, function () {
                        loadData(models.eruu.hyanalt, 'eruuhyanalt/search', searchData, function () {
                        })
                    })
                })


                loadData(models.zahirgaa.anhan, 'zahirgaaanhan/search', searchData, function () {
                    loadData(models.zahirgaa.davah, 'zahirgaadavah/search', searchData, function () {
                        loadData(models.zahirgaa.hyanalt, 'zahirgaahyanalt/search', searchData, function () {
                        })
                    })
                })

                callback(true)
            }, function (err) {
                callback(false)
            });

        }

        init(function (res) {
        });

        function loadData1(obj, action, req, callback) {
            Connection.r(action, req).then(function (res) {
                obj.list = res.data;
                obj.header = res.header;
                return callback(res, null)
            }, function (err) {
                return callback(null, err)
            });
        }

        function loadData(obj, action, req, callback) {
            Connection1.r(action, req).then(function (res) {
                obj.list = res.data;
                obj.header = res.header;
                return callback(res, null)
            }, function (err) {
                return callback(null, err)
            });
        }

        function loadObj(obj, action, req, callback) {
            Connection1.r(action, req).then(function (res) {
                obj = res[0];
                return callback(res, null)
            }, function (err) {
                return callback(null, err)
            });
        }

        function call(obj, action, req, callback) {
            Connection1.r(action, req).then(function (res) {
                console.log('res: ', res)
                obj = res;
                return callback(res, null)
            }, function (err) {
                return callback(null, err)
            });
        }

        return {
            searchData: searchData,
            models: models,
            init: function (callback) {
                return init(callback);
            },
            loadData: function (obj, action, req, callback) {
                return loadData(obj, action, req, callback);
            },
            loadData1: function (obj, action, req, callback) {
                return loadData1(obj, action, req, callback);
            },
            call: function (obj, action, req, callback) {
                return call(obj, action, req, callback);
            }
        }
    });
